# objectstore
:construction: Master Ci status: [![Build Status](https://magnum.travis-ci.com/owncloud/objectstore.svg?token=q8ZoWBCat8DFpZ2ALfXP&branch=master)](https://magnum.travis-ci.com/owncloud/objectstore)

## Installation
Just clone this repo into your apps directory. Additionally you need Composer to install dependencies:
```bash
curl -sS https://getcomposer.org/installer | php
php composer.phar install
```

## Set Up
Object storage can not yet be set up with the installation dialog. For now just leave the default data folder path and manually configure the objectstore after installation.

## Configuration
To activate object store mode add a `objectstore` entry to the config.php as shown in the examples below.

The objectstore kind of replaces the data directory. By default, the ownCloud log file and the sqlite db will be saved in the data directory. Even when objectstore is configured. However, sqlite is highly unlikely to be used in conjunction with objectstore and the log file path can be changed in config.php. So, in theory the data folder can be empty. However old apps might not use our stream wrappers to access their data and as a result a writable data folder might be needed to achieve backward compatibility.

## Examples
### Amazon S3
Tested with a real s3 account
```php
  'objectstore' => array(
    'class' => 'OCA\ObjectStore\S3',
        'arguments' => array(
          // replace key, secret and bucket with your credentials
          'key' => 'GEZ550B06Z2ZDB52CT21',
          'secret' => '6Vdo7ObSMBlI4TMRw0jpRE75K6qS9QNTk6nBboxP',
          'bucket' => 'your-oc-exclusive-bucket',
        ),
  ),
```

### ceph s3
Tested with http://www.sebastien-han.fr/blog/2013/04/22/play-with-ceph-vagrant-box/
```php
  'objectstore' => array(
    'class' => 'OCA\ObjectStore\S3',
	'arguments' => array(
	  // replace key & secret with your credentials
	  'key' => 'GEZ550B06Z2ZDB52CT21',
	  'secret' => '6Vdo7ObSMBlI4TMRw0jpRE75K6qS9QNTk6nBboxP',
	  'bucket' => 'devobjectstore',
	  'base_url' => 'http://ceph/',
	  'hostname' => 'ceph',
	  // you must use this region or the amazon lib will overwrite
	  // the path style when resetting the region
	  'region' => 's3-eu-west-1.amazonaws.com'
	),
  ),
```
